'******************************************************************************
' PROJECT: Quick Tab Visual Designer SDK generated code for BCX.
' FILE:    Your file name
' CREATED: On 07-23-2004 at 13:20:04
'******************************************************************************
'
' Just a simple ListView Demo for WinCE - Compiled & tested with eVC++ 3.0 on the emulator
' Put some Text in a list view control
' Click on a row ant the Text will but put in the Edit boxes
' Edit text and click on save to put the data back into the Listview.
'
'The ListView functions will most likely will work in regular Windows too
'
'by Ian Casey 7/24/04 & Vic's BCX version of QTab
'
'for demo purposes only

$NOWIN
$CPP

'****************************************
'Remember to change the Paths
'****************************************
$ONEXIT "C:\Programming\BCX\WinCe\XLator\bcx2unicode.EXE C:\Programming\BCX\WinCe\LVTest\LVTest.cpp"
'****************************************

'COMPILE WITH eVC++ 3.0 FOR POCKET PC
$HEADER
#ifndef _UNICODE
  #define _UNICODE
#endif
$HEADER

#include <tchar.h>
#include <windows.h>
#include <windowsx.h>
#include <wingdi.h>
#include <winbase.h>
#include <winuser.h>
#include <oleidl.h>
#include <afxwin.h>
#include <wcealt.h>
#include <commdlg.h>

'Remember to change the Path
$include "c:\programming\bcx\wince\LVTest\CEFunctions.bas"
$include "c:\programming\bcx\wince\LVTest\PPConlyFunctions.bas"
' Stuff added because it's missing in Jacob's WIN.H - QTab
'Already added - I forget which header file in WinCE
'CONST MCN_SELECT = (MCN_FIRST + 4)
'CONST LVM_GETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 55)
'CONST ListView_GetExtendedListViewStyle(hwndLV) = (DWORD)SNDMSG((hwndLV), LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0)
'CONST LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54)
'CONST ListView_SetExtendedListViewStyle(hwndLV, dw) = (DWORD)SNDMSG((hwndLV), LVM_SETEXTENDEDLISTVIEWSTYLE, 0, dw)

'---Main Tab Identifiers
CONST IDTAB_MAIN	 = 100
CONST IDTAB_PAGE_1	 = 101
CONST IDC_OK    	 = 102
CONST IDC_CANCEL	 = 103
CONST IDC_APPLY 	 = 104

CONST   IDR_MENUBAR1    = 1001

'---Page 1 control identifiers
CONST IDC_LISTVIEW_1 = 2000
CONST IDC_EDIT_1     = 2001 
CONST IDC_EDIT_2     = 2002 
CONST IDC_EditSave   = 2003
CONST IDC_DelRow   = 2004

Global hIDC_LISTVIEW_1 AS HWND
Global hIDC_EDIT_1 AS HWND
Global hIDC_EDIT_2 AS HWND
Global hIDC_EditSave AS HWND
Global hIDC_DelRow AS HWND

'iEditRow Used to keep track of ListView Line being edited
'if no line being edited set to -1 so new line is created
'when necessary - IDC
Global iEditRow AS Integer

DIM hwndCB      AS HWND			'The command bar handle


'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
FUNCTION WINMAIN

	LOCAL hWnd AS HWND,rc AS RECT,twcx AS WNDCLASS
	LOCAL Style AS DWORD,StyleEx AS DWORD,hRichEditDLL AS HANDLE
	LOCAL szCaption$,szClassName$
	LOCAL ticc AS INITCOMMONCONTROLSEX,tMsg AS MSG


	'Register the Main application window...
	szClassName$       = "WINMAINAPP"
	'twcx.cbSize        = SIZEOF(twcx)
	twcx.style         = 0
	twcx.lpfnWndProc   = WinMainWndProc
	twcx.cbClsExtra    = 0
	twcx.cbWndExtra    = 0
	twcx.hInstance     = hInst
	twcx.hIcon         = NULL 'LoadIcon(NULL,IDI_APPLICATION)
	twcx.hCursor       = LoadCursor(NULL,IDC_ARROW)
	twcx.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1)
	twcx.lpszMenuName  = NULL
	twcx.lpszClassName = (szClassName$)
	'twcx.hIconSm       = LoadIcon(NULL,IDI_APPLICATION)
	RegisterClass(&twcx)

	'Register the Tab page holder windows...
	szClassName$       = "TABPAGEHOLDER"
	'twcx.cbSize        = SIZEOF(twcx)
	twcx.style         = 0
	twcx.lpfnWndProc   = TabPageHolderWndProc
	twcx.cbClsExtra    = 0
	twcx.cbWndExtra    = 0
	twcx.hInstance     = hInst
	twcx.hIcon         = NULL
	twcx.hCursor       = NULL
	twcx.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1)
	twcx.lpszMenuName  = NULL
	twcx.lpszClassName = (szClassName$)
	'twcx.hIconSm       = NULL
	RegisterClass(&twcx)

	'Load the common controls library...
	ticc.dwSize = SIZEOF(ticc)
	ticc.dwICC = ICC_TAB_CLASSES OR ICC_DATE_CLASSES
	InitCommonControlsEx(&ticc)

	szCaption$ = "BCX WinCE Listview Test"
	Style   = WS_VISIBLE OR WS_CAPTION OR WS_SYSMENU
	StyleEx = WS_EX_WINDOWEDGE

    Dim myErr as integer
    myErr = GetCeRect(&rc)
	'Create the Main application window...
	hWnd = CreateWindowEx(StyleEx,"WINMAINAPP",szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      HWND_DESKTOP,NULL,hInst, NULL)

	ShowWindow(hWnd,SW_NORMAL)
	UpdateWindow(hWnd)

	WHILE GetMessage(&tMsg, NULL, 0, 0)
	    IF NOT IsDialogMessage(hWnd, &tMsg) THEN
	        TranslateMessage(&tMsg)
	        DispatchMessage(&tMsg)
	    END IF
	WEND

	FUNCTION = tMsg.wParam
END FUNCTION

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
CALLBACK FUNCTION WinMainWndProc

	LOCAL hFontTab AS HWND,hInst AS HINSTANCE
	LOCAL ptnmhdr AS NMHDR PTR,PageNo AS LONG

	hInst = GetModuleHandle(NULL)

	SELECT CASE (Msg)

	    CASE WM_CREATE
	        'add the main tab control...
	        GLOBAL ghTab[1] AS HWND
	        CreateMainTabControl(hWnd)

	        CreateMainAppButtons(hWnd)
	        SetFocus(GetDlgItem(hWnd,IDC_OK))

	    'SHCMBF_EMPTYBAR for flags creates empty Menu with PopUp Keyboard
  	     hwndCB = CreateMenuBarCE( hWnd, hInst, _
                        IDR_MENUBAR1,SHCMBF_EMPTYBAR , _
                        hwndCB , TRUE)

	    CASE WM_COMMAND
	        SELECT CASE LOWORD(wParam)
	            CASE IDC_OK
	                IF HIWORD(wParam) = BN_CLICKED THEN
	                    SendMessage(hWnd,WM_CLOSE,0,0)
	                END IF
	            CASE IDC_CANCEL,IDCANCEL
	                IF HIWORD(wParam) = BN_CLICKED THEN
	                    SendMessage(hWnd,WM_CLOSE,0,0)
	                END IF
	            CASE IDC_APPLY
	                IF HIWORD(wParam) = BN_CLICKED THEN
	                    '
	                END IF
	        END SELECT

	    CASE WM_NOTIFY  'Trap main tab notifications...
	        ptnmhdr = (NMHDR PTR) lParam
	        SELECT CASE ptnmhdr->code
	          CASE TCN_LAST TO TCN_FIRST
	            SELECT CASE ptnmhdr->idFrom
	              CASE IDTAB_MAIN
	                SELECT CASE ptnmhdr->code
	                  CASE TCN_SELCHANGING
	                    PageNo =SendMessage(GetDlgItem(hWnd,IDTAB_MAIN),TCM_GETCURSEL,0,0)
	                    ShowWindow(ghTab[PageNo],SW_HIDE)
	                  CASE TCN_SELCHANGE
	                    PageNo = SendMessage(GetDlgItem(hWnd,IDTAB_MAIN),TCM_GETCURSEL,0,0)
	                    ShowWindow(ghTab[PageNo],SW_SHOW)
	                END SELECT
	            END SELECT
	        END SELECT

	    CASE WM_CLOSE
	        SendMessage(hWnd,WM_DESTROY,0,0)

	    CASE WM_DESTROY
	        'destroy the tab control font...
	        hFontTab = (HWND) SendMessage(GetDlgItem(hWnd,IDTAB_MAIN),WM_GETFONT,0,0)
	        IF hFontTab THEN DeleteObject(hFontTab)

	        'destroy all tab page control parents...
	        DestroyWindow(GetDlgItem(hWnd,IDTAB_PAGE_1))

	        PostQuitMessage(0)

	END SELECT
		FUNCTION = DefWindowProc(hWnd,Msg,wParam,lParam)
END FUNCTION

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
FUNCTION CreateMainTabControl(hWnd AS HWND) AS HWND

	LOCAL hFontTab AS HFONT,hInst AS HINSTANCE,hMainTab AS HWND,i AS LONG
	LOCAL Style AS DWORD,StyleEx AS DWORD,rc AS RECT,ttc_item AS TC_ITEM
	LOCAL szCaption$,szItem$

	hInst = GetModuleHandle(NULL)

	Style = WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR _
	        TCS_TABS OR TCS_SINGLELINE OR TCS_FOCUSONBUTTONDOWN
	StyleEx = 0
	SetRect(&rc,6,6,220,220)

	'Create tab control...
	hMainTab = CreateWindowEx(StyleEx,"SysTabControl32","",Style, _
	                          rc.left,rc.top,rc.right,rc.bottom, _
	                          hWnd, (HMENU)(IDTAB_MAIN),hInst,NULL)

	hFontTab = MakeFontEx("Tahoma",8,0,0,0,0)
	SendMessage(hMainTab,WM_SETFONT,hFontTab,TRUE)

	'Insert tabs in the tab control...
	DIM sText$[1]
	sText$[0] = "Tab1"

	FOR i = 0 TO 0
	    szItem$             = sText$[i]
	    ttc_item.mask       = TCIF_TEXT
	    ttc_item.pszText    = szItem$
	    ttc_item.cchTextMax = LEN(szItem$)
	    ttc_item.iImage     = -1
	    ttc_item.lParam     = 0
	    SendMessage(hMainTab,TCM_INSERTITEM,i, &ttc_item)
	NEXT

	'Create the individual Tab Pages...

	Style   = WS_CHILD
	StyleEx = WS_EX_CONTROLPARENT

	'allow the tab pages to fit evenly within the tab control...
	SetTabPageRectSDK(hMainTab,&rc)

	FOR i = 0 TO 0
	    ghTab[i] = CreateWindowEx(StyleEx,"TABPAGEHOLDER","",Style, _
	                             rc.left,rc.top,rc.right,rc.bottom, _
	                             hMainTab, (HMENU)(IDTAB_PAGE_1+i),hInst,NULL)
	NEXT

	'Show Tab 1 as the default page...
	ShowWindow(ghTab[0], SW_SHOW)

	FUNCTION = hMainTab

END FUNCTION

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
CALLBACK FUNCTION TabPageHolderWndProc

	LOCAL hFontCtl AS HFONT,hCtlChild AS HWND,hInst AS HINSTANCE,TabPageID AS INTEGER

	hInst = GetModuleHandle(NULL)
	TabPageID = GetDlgCtrlID(hWnd)

	SELECT CASE (Msg)

	    CASE WM_CREATE
	        SELECT CASE (TabPageID)
	            CASE IDTAB_PAGE_1  :CreateControlTabPage1(hWnd)
	        END SELECT

	    CASE WM_COMMAND, WM_NOTIFY, WM_HSCROLL, WM_VSCROLL
	        SELECT CASE (TabPageID)
	            CASE IDTAB_PAGE_1  :MessageHandlerTabPage1(hWnd,Msg,wParam,lParam)
	        END SELECT

	    CASE WM_DESTROY
	        'Delete fonts for all controls on each page...
	        hCtlChild = GetWindow(hWnd,GW_CHILD)
	        WHILE hCtlChild
	            hFontCtl = (HFONT) SendMessage(hCtlChild,WM_GETFONT,0,0)
	            IF hFontCtl THEN DeleteObject(hFontCtl)
	            hCtlChild = GetWindow(hCtlChild, GW_HWNDNEXT)
	        WEND

	END SELECT

	FUNCTION = DefWindowProc(hWnd,Msg,wParam,lParam)
END FUNCTION

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
CALLBACK FUNCTION MessageHandlerTabPage1

	LOCAL ptnmhdr AS NMHDR PTR
  Local pItem AS LV_ITEM
  Local lpnmlv AS LPNMLISTVIEW
  Local szBuffer$
  Local lCount as Long
	SELECT CASE (Msg)

	    CASE WM_COMMAND
	        SELECT CASE LOWORD(wParam)
	            CASE IDC_EDIT_1
	                SELECT CASE HIWORD(wParam)
	                    CASE EN_CHANGE
	                END SELECT
	            CASE IDC_EDIT_2
	                SELECT CASE HIWORD(wParam)
	                    CASE EN_CHANGE
	                END SELECT
	             CASE IDC_EditSave
	                IF HIWORD(wParam) = BN_CLICKED THEN
	                   Call PutLVRowFromEdit(hIDC_LISTVIEW_1,iEditRow)
	                END IF
	             CASE IDC_DelRow
	                IF HIWORD(wParam) = BN_CLICKED THEN
                     Call DeleteListViewRow(hIDC_LISTVIEW_1, iEditRow)
                  END IF
	        END SELECT

	    CASE WM_NOTIFY
	        ptnmhdr = (NMHDR PTR) lParam
	        SELECT CASE ptnmhdr->idFrom
	            CASE IDC_LISTVIEW_1		'Listview...
	                SELECT CASE ptnmhdr->code
	                    CASE LVN_COLUMNCLICK
	                    CASE LVN_ITEMCHANGED
	                    CASE NM_CLICK  
	                     'clicked on listview
	                       lpnmlv = (LPNMLISTVIEW) lParam
	                       iEditRow =lpnmlv->iItem
	                       'Sent Row to Edit boxes
	                       GetLVRowToEdit(hIDC_LISTVIEW_1	, iEditRow)

	                END SELECT
	        END SELECT

	END SELECT

END FUNCTION


'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
SUB CreateControlTabPage1(hTab AS HWND)

	LOCAL hCtl AS HWND,hFont AS HFONT,hInst AS HINSTANCE,hImage AS HANDLE
	LOCAL Style AS DWORD,StyleEx AS DWORD,lflags AS DWORD
	LOCAL szCaption$,szAviName$
	LOCAL sText$,rc AS RECT

	hInst = GetModuleHandle(NULL)

	'---
	szCaption$ = "ListView1"
	SetRect(&rc,4,4,132,102)

	Style   = WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR _
	          WS_VISIBLE OR LVS_ALIGNLEFT OR LVS_EDITLABELS OR _
	          LVS_REPORT OR LVS_SHOWSELALWAYS OR LVS_SINGLESEL 
	StyleEx = WS_EX_CLIENTEDGE

	hIDC_LISTVIEW_1 = CreateWindowEx(StyleEx, "SysListView32", szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      hTab,(HMENU)(IDC_LISTVIEW_1), hInst, NULL)

	hFont = MakeFontEx("Tahoma",8,400,0,0,0)
	SendMessage(hCtl,WM_SETFONT,hFont,TRUE)

	'---
	szCaption$ = "Edit1"
	SetRect(&rc,12,112,54,24)

	Style   = WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR WS_VISIBLE
	StyleEx = WS_EX_CLIENTEDGE

	hIDC_EDIT_1 = CreateWindowEx(StyleEx, "EDIT", szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      hTab,(HMENU)(IDC_EDIT_1), hInst, NULL)

	hFont = MakeFontEx("Tahoma",8,400,0,0,0)
	SendMessage(hIDC_EDIT_1,WM_SETFONT,hFont,TRUE)

	'---
	szCaption$ = "Edit2"
	SetRect(&rc,78,112,66,24)

	Style   = WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR WS_VISIBLE
	StyleEx = WS_EX_CLIENTEDGE

	hIDC_EDIT_2 = CreateWindowEx(StyleEx, "EDIT", szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      hTab,(HMENU)(IDC_EDIT_2), hInst, NULL)

	hFont = MakeFontEx("Tahoma",8,400,0,0,0)
	SendMessage(hIDC_EDIT_2,WM_SETFONT,hFont,TRUE)
	
	szCaption$ = "&Save"
	SetRect(&rc,25,140,60,30)
	Style   = WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR _
	          WS_VISIBLE OR BS_PUSHBUTTON
	StyleEx = 0
	hIDC_EditSave = CreateWindowEx(StyleEx, "BUTTON", szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      hTab, (HMENU)(IDC_EditSave), hInst, NULL)

	szCaption$ = "&Del Row"
	SetRect(&rc,100,140,60,30)
	Style   = WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR _
	          WS_VISIBLE OR BS_PUSHBUTTON
	StyleEx = 0
	hIDC_DelRow = CreateWindowEx(StyleEx, "BUTTON", szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      hTab, (HMENU)(IDC_DelRow), hInst, NULL)

	LoadListView(hTab,IDC_LISTVIEW_1,3,5)

END SUB

'------------------------------------------------------------------------------
'  ** Helper routines **
'------------------------------------------------------------------------------
SUB CreateMainAppButtons(hWnd AS HWND)

	LOCAL hCtl AS HWND,hInst AS HINSTANCE,Style AS DWORD,StyleEx AS DWORD
	LOCAL szCaption$,rc AS RECT,rcm AS RECT
	LOCAL cap AS LONG, bord AS LONG,tm AS LONG,gap AS LONG

	hInst = GetModuleHandle(NULL)

	GetClientRect(hWnd,&rcm)
	cap = GetSystemMetrics(SM_CYCAPTION)
	bord = GetSystemMetrics(SM_CXBORDER)
	tm  = 6
	gap = 6

	'---
	szCaption$ = "&OK"
	SetRect(&rc,rcm.right+bord-tm-180-gap*2,rcm.bottom-cap-12,60,30)
	Style   = WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR _
	          WS_VISIBLE OR BS_PUSHBUTTON
	StyleEx = 0
	hCtl = CreateWindowEx(StyleEx, "BUTTON", szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      hWnd, (HMENU)(IDC_OK), hInst, NULL)
	'---
	szCaption$ = "&Cancel" 
	SetRect(&rc,rcm.right+bord-tm-120-gap,rcm.bottom-cap-12,60,30)
	Style   = WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR _
	          WS_VISIBLE OR BS_PUSHBUTTON
	StyleEx = 0
	hCtl = CreateWindowEx(StyleEx, "BUTTON", szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      hWnd, (HMENU)(IDC_CANCEL), hInst, NULL)
	'---
	szCaption$ = "&Apply" 
	SetRect(&rc,rcm.right+bord-tm-60,rcm.bottom-cap-12,60,30)
	Style   = WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR _
	          WS_VISIBLE OR BS_PUSHBUTTON
	StyleEx = 0
	hCtl = CreateWindowEx(StyleEx, "BUTTON", szCaption$,Style, _
	                      rc.left,rc.top,rc.right,rc.bottom, _
	                      hWnd, (HMENU)(IDC_APPLY), hInst, NULL)

END SUB

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
SUB SetTabPageRectSDK(hTab AS HWND, rcReturn AS LPRECT)

	LOCAL tRect AS RECT,twRect AS RECT,pRect AS RECT
	LOCAL b AS LONG,l AS LONG,r AS LONG,t AS LONG
	LOCAL lb AS LONG,tb AS LONG,c AS LONG,f AS LONG,tm AS LONG

	GetWindowRect(hTab,&twRect)
	GetWindowRect(GetParent(hTab),&pRect)

	lb = twRect.left-pRect.left
	tb = twRect.top-pRect.top
	c  = GetSystemMetrics(SM_CYCAPTION)
	f  = GetSystemMetrics(SM_CXBORDER)

	SendMessage(hTab,TCM_GETITEMRECT,0, &tRect)

	tm = 8
	l  = lb-2*f+tm
	t  = tb-c-f+tRect.bottom+tm
	r  = twRect.right-twRect.left-4*f-2*tm
	b  = twRect.bottom-twRect.top-tRect.bottom-4*f-2*tm

	SetRect(rcReturn,l,t,r,b)

END SUB

'------------------------------------------------------------------------------
' Create a desirable font and return its handle.
' Enhanced with proper enumeration of character set via EnumCharSet.
' Original code by Dave Navarro, Enhancement by Borje Hagsten.
'**************************************
' I HAVE CHANGED THIS FROM QTAB CODE
' TO USE *******  CreateFontIndirect ******
'IDC
'**************************************
'------------------------------------------------------------------------------
FUNCTION MakeFontEx(sFont$, PointSize AS LONG, fBold AS LONG, _ 
                    fItalic AS LONG, fUnderline AS LONG, StrikeThru AS LONG) AS HFONT

	LOCAL hDC AS HDC, CharSet AS LONG, CyPixels AS LONG
  LOCAL getFont AS LOGFONT
	hDC = GetDC(HWND_DESKTOP)
	CyPixels  = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC (HWND_DESKTOP, hDC)

	PointSize = 0 - (PointSize * CyPixels) / 72

  getFont.lfHeight = PointSize
  getFont.lfWidth = 0
  getFont.lfEscapement = 0
  getFont.lfOrientation = 0
  getFont.lfWeight = fBold
  getFont.lfItalic = uchar(fItalic)
  getFont.lfUnderline = uchar(fUnderline)
  getFont.lfStrikeOut = uchar(StrikeThru)
  getFont.lfCharSet = uchar(CharSet)
  getFont.lfOutPrecision = OUT_TT_PRECIS
  getFont.lfClipPrecision = CLIP_DEFAULT_PRECIS
  getFont.lfQuality = DEFAULT_QUALITY
  getFont.lfPitchAndFamily = FF_DONTCARE
  concat(getFont.lfFaceName, sFont$)

  FUNCTION = CreateFontIndirect(&getFont)


END FUNCTION

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
SUB SetCtlTooltip(hCtl AS HWND,sText$)
$COMMENT
	STATIC hTooltip AS HWND,hInst AS HINSTANCE 
	LOCAL ti AS TOOLINFO,szText$ 

	hInst = GetModuleHandle(NULL)

	IF hTooltip  = 0 THEN
	    hTooltip = CreateWindowEx(0,"tooltips_class32","",TTS_ALWAYSTIP, _ 
	                              0,0,0,0,0,NULL,hInst,NULL)
	END IF

	IF hTooltip THEN
	    szText$     = sText$
	    ti.cbSize   = sizeof(ti)
	    ti.uFlags   = TTF_SUBCLASS OR TTF_IDISHWND
	    ti.hwnd     = GetParent(hCtl)
	    ti.uId      = (UINT)hCtl
	    ti.lpszText = szText$
	    SendMessage(hTooltip,TTM_ADDTOOL,0,&ti)
	END IF
$COMMENT
END SUB

'--------------------------------------------------------------------------------
' ** Sample code from QTab   *******modified a little BY idc******
'--------------------------------------------------------------------------------
FUNCTION LoadListView(hWnd AS HWND,lID AS LONG,lColCnt AS LONG, lRowCnt AS LONG) AS LONG

	LOCAL lStyle AS LONG,tLVC AS LV_COLUMN,tLVI AS LV_ITEM
	LOCAL szBuf$,lCol AS LONG,lRow AS LONG,hCtl AS HWND
	LOCAL prc AS RECT
	hCtl = GetDlgItem(hWnd,lID)

	lStyle = ListView_GetExtendedListViewStyle(hCtl)
	ListView_SetExtendedListViewStyle( hCtl, _
	    lStyle OR LVS_EX_FULLROWSELECT OR LVS_EX_GRIDLINES)

	'Load column headers.
	tLVC.mask    = LVCF_FMT OR LVCF_TEXT OR LVCF_SUBITEM
	tLVC.fmt     = LVCFMT_LEFT
	tLVC.pszText = szBuf$
	FOR lCol = 0 TO lColCnt - 1
	    szBuf$ = "Column" & TRIM$(STR$(lCol))
	    tLVC.iSubItem = lCol
	   ListView_InsertColumn(hCtl, lCol, &tLVC)
	NEXT lCol

	'Load sample data.
	FOR lRow = 0 TO lRowCnt - 1
	    tLVI.stateMask   = LVIS_FOCUSED
	    tLVI.pszText     = szBuf$
	    tLVI.iItem       = lRow
	    FOR lCol = 0 TO lColCnt - 1
	      If lCol = 0 then
          szBuf$ = str$(lRow + 1)
	      else
	        szBuf$          = JOIN$(4, "C", TRIM$(STR$(lCol)), " R", TRIM$(STR$(lRow)))
	      End If
	        tLVI.iSubItem   = lCol
	        tLVI.lParam     = lRow
	        IF lCol = 0 THEN
	            tLVI.mask = LVIF_TEXT OR LVIF_PARAM OR LVIF_STATE
	            ListView_InsertItem(hCtl, &tLVI)
	        ELSE
	            tLVI.mask = LVIF_TEXT
	            ListView_SetItem(hCtl, &tLVI)
	        END IF
	    NEXT lCol
	NEXT i

'Set Column 0 to 25 pixels - just column #
'Auto size the other columns.
'	FOR lCol = 1 TO lColCnt - 1
'	    ListView_SetColumnWidth(hCtl, lCol, LVSCW_AUTOSIZE)
'	NEXT lCol

  'Fit the columns to control size - column 0 width
  GetWindowRect(hCtl,&prc)
  Dim EqualColsWidth As Integer
  ListView_SetColumnWidth(hCtl, 0, 20)
  '23 is for Width col 0(line above) + 1 pix per colunm gridline
  EqualColsWidth = ((prc.right - prc.left- 23 )/2)
  'MsgBox( "Width is " & str$(EqualColsWidth))
	FOR lCol = 1 TO lColCnt - 1
	    ListView_SetColumnWidth(hCtl, lCol, EqualColsWidth)
	NEXT lCol

  iEditRow = -1
  FUNCTION=1

END FUNCTION

'**********************************************
'Get Data from ListView and put in Edit boxes
'**********************************************
Sub GetLVRowToEdit(hCtrl As HWND, lRow as int)
  Local szBuffer$
    iEditRow =lRow
		szBuffer$ = GetListItemText(hCtrl, 1, lRow)
		SetWindowText(hIDC_EDIT_1,szBuffer$)
		szBuffer$ = ""
		'IMPORTANT - pItem will be cleared after call to ListView_GetItem
		szBuffer$ = GetListItemText(hCtrl, 2, lRow)
		SetWindowText(hIDC_EDIT_2,szBuffer$)
End Sub

'**********************************************
'Get Data from Edit boxes and put in ListView
'**********************************************
Sub PutLVRowFromEdit(hCtrl As HWND, lRow as int)
  Local lCount AS Long
  Local szBuffer1$
  Local szBuffer2$

    lCount = GetWindowText(hIDC_EDIT_1,szBuffer1$,16)
    If Len(trim$(szBuffer1$)) <> 0 then
      If iEditRow = -1 then
        'It's a new row, get last row and insert new row
        lCount = ListView_GetItemCount(hCtrl) + 1
        lCount = AddListViewRow(lCount )
         iEditRow = lCount -1
      End If
      lCount =  PutListItemText(hIDC_LISTVIEW_1, 1, iEditRow, szBuffer1$)
	    lCount = GetWindowText(hIDC_EDIT_2,szBuffer2$,16)
      lCount =  PutListItemText(hIDC_LISTVIEW_1, 2, iEditRow, szBuffer2$)
      'Clear the Edit boxes
      SetWindowText(hIDC_EDIT_1,"")
      SetWindowText(hIDC_EDIT_2,"")
    End If
    iEditRow = -1
End Sub

'**********************************************
'Get Data from ListView
'**********************************************
Function GetListItemText(hCtrl As HWND, lCol as int, lRow as int) As String

  Local pItem AS LV_ITEM
  Local szBuffer$

    pItem.mask =  LVIF_TEXT  OR LVIS_FOCUSED 'LVCF_SUBITEM
		pItem.iSubItem = lCol
		pItem.iItem = lRow
		pItem.pszText = szBuffer$
		pItem.lParam = lRow
		pItem.cchTextMax = 16
		ListView_GetItem(hIDC_LISTVIEW_1,&pItem)
  Function = szBuffer$

End Function

'**********************************************
'Put Data in ListView
'**********************************************
Function PutListItemText(hCtrl As HWND, lCol as int, lRow as int, szBuffer$ As String) As Long

  Local pItem AS LV_ITEM
  Local ErrCode As Long
  GetLastError()
    pItem.mask =  LVIF_TEXT  OR LVIS_FOCUSED 'LVCF_SUBITEM
		pItem.iSubItem = lCol
		pItem.iItem = lRow
		pItem.pszText = szBuffer$
		pItem.lParam = lRow
		pItem.cchTextMax = 16
		ListView_SetItem(hIDC_LISTVIEW_1,&pItem)
  Function = CLng(GetLastError())
End Function

'**********************************************
'Add a Row to ListView
'**********************************************
Function AddListViewRow(lRow as Integer) as Long
  Local pItem AS LV_ITEM
  Local lCount AS Long

 	    pItem.stateMask   = LVIS_FOCUSED
	    pItem.pszText     = str$(lRow)
	    pItem.iItem       = lRow
	    pItem.iSubItem   = 0
	    pItem.lParam     = lRow
	    pItem.mask = LVIF_TEXT OR LVIF_PARAM OR LVIF_STATE
      lCount =  ListView_InsertItem(hIDC_LISTVIEW_1,&pItem)
  Function = lRow
End Function

'**********************************************
'Delete a Row from ListView
'**********************************************
Function DeleteListViewRow(hCtrl As HWND, lRow as int) as Long
  Dim i as integer
  Dim j as integer
  Dim lCount As Long

  ListView_DeleteItem(hCtrl,lRow)
  lCount = ListView_GetItemCount(hCtrl)
  For i = 0 to lCount -1
    j =  PutListItemText(hCtrl, 0, i, str$(i+1))
  Next i
  iEditRow = -1
  Function = 0
End Function




